part of xwidgetbase;

class XBtnbase extends StatelessWidget {
  final String? label;
  final TextStyle? styleLabel;
  final AlignmentGeometry? alignmentLabel;

  ///Da il colore a tutti i tipi di testo
  final Color? textColor;
  final IconData? icon;
  final Color? iconColor;
  final double? iconSize;

  final double? widthBTN;
  final double? heightBTN;
  final Color? colorBTN;
  final Decoration? decorationBTN;
  final double? radiusBorder;
  final double? elevation;
  final double? widthAreaOfIcon;
  final EdgeInsets? paddingBTNContent;
  final EdgeInsets? marginBTN;
  final bool? enableFeedback;

  final String? nameOfPageToGo;
  final BuildContext? buildContextOfPage;
  final Function()? onPressed;
  final TextAlign? textAlignLabel;
  final Widget? iconWidget;
  final String? message_ToolTip;

  XBtnbase({
    this.label = "",
    this.decorationBTN,
    this.iconWidget,
    this.enableFeedback = true,
    this.paddingBTNContent,
    this.marginBTN,
    this.radiusBorder,
    this.widthBTN,
    this.heightBTN,
    this.alignmentLabel,
    this.elevation,
    this.buildContextOfPage,
    this.icon,
    this.textAlignLabel,
    this.nameOfPageToGo = "",
    this.styleLabel,
    this.iconSize = 28,
    this.colorBTN,
    this.textColor,
    this.iconColor = Colors.black,
    this.onPressed,
    this.widthAreaOfIcon,
    this.message_ToolTip,
  });

  static onlyBorderAndLabel({
    String? label = "Inserisci Label",
    double? widthBTN = 250,
    double? heightBTN,
    Function()? onPressed,
    Color? colorBorder = Colors.greenAccent,
    double? widthBorder = 2,
    Color? colorBackGround,
    Color? labelColor = Colors.greenAccent,
    TextAlign? textAlignLabel = TextAlign.center,
    double? borderRadius = 5,
  }) {
    return XBtnbase(
      elevation: 0,
      widthBTN: widthBTN,
      heightBTN: heightBTN,
      textAlignLabel: textAlignLabel,
      label: label,
      styleLabel: XStyles.xStyTextForLabel(labelColor ?? colorBorder),
      decorationBTN: XDecoration.onlyBorder(
        borderRadius: borderRadius!,
        colorBackGround: colorBackGround ?? Colors.grey[900],
        widthBorder: widthBorder!,
        colorBorder: colorBorder!,
      ),
      onPressed: onPressed,
    );
  }

  static ForMenu({
    String? label = "Inserisci Label",
    double? widthBTN = 250,
    double? heightBTN,
    Function()? onPressed,
    Color? colorBorder = Colors.greenAccent,
    double? widthBorder = 2,
    Color? colorBackGround,
    Color? labelColor = Colors.greenAccent,
    TextAlign? textAlignLabel = TextAlign.center,
    double? borderRadius = 5,
  }) {
    return XBtnbase.onlyBorderAndLabel(
      widthBTN: widthBTN,
      heightBTN: heightBTN,
      labelColor: labelColor,
      colorBorder: colorBorder,
      onPressed: onPressed,
      colorBackGround: colorBackGround,
      label: label,
    );
  }

  @override
  Widget build(BuildContext context) {
    return Tooltip(
        preferBelow: true,
        message: message_ToolTip ?? "",
        child: Container(
            width: (label != "" || widthBTN != null) ? widthBTN : 40,
            height: (label != "" || heightBTN != null) ? heightBTN : 40,
            margin: marginBTN ?? null,
            alignment: Alignment.center,
            decoration: decorationBTN ?? BoxDecoration(color: colorBTN, borderRadius: BorderRadius.all(Radius.circular(radiusBorder ?? 0))),
            child: ElevatedButton(
              style: ElevatedButton.styleFrom(
                elevation: elevation ?? 0,
                backgroundColor: Colors.transparent,
                alignment: Alignment.centerLeft,
                padding: paddingBTNContent ?? EdgeInsets.all(5),
                enableFeedback: enableFeedback,
              ),
              onPressed: nameOfPageToGo != "" ? () => Navigator.pushNamed(buildContextOfPage!, nameOfPageToGo!) : onPressed,
              child: (icon != null && (label == null || label == ""))
                  ? Container(
                      color: Colors.transparent,
                      alignment: Alignment.center,
                      child: Row(mainAxisSize: MainAxisSize.min, crossAxisAlignment: CrossAxisAlignment.center, mainAxisAlignment: MainAxisAlignment.center, children: [
                        Container(
                          color: Colors.transparent,
                          alignment: Alignment.center,
                          child: Icon(icon, color: iconColor, size: iconSize),
                        )
                      ]))
                  : Row(
                      crossAxisAlignment: CrossAxisAlignment.center,
                      mainAxisAlignment: MainAxisAlignment.center,
                      children: [
                        iconWidget == null
                            ? icon != null
                                ? Container(
                                    color: Colors.transparent,
                                    width: widthAreaOfIcon ?? 40,
                                    alignment: Alignment.center,
                                    child: Icon(icon, color: iconColor, size: iconSize),
                                  )
                                : Container()
                            : iconWidget ?? Container(),
                        label != null
                            ? Expanded(
                                child: Container(
                                    color: Colors.transparent,
                                    alignment: alignmentLabel ?? Alignment.center,
                                    child: Text(
                                      label!,
                                      style: styleLabel ?? XStyles.xStyleText(fontSize: 14, colorText: textColor),
                                      textAlign: textAlignLabel ?? TextAlign.center,
                                    )))
                            : Container(),
                      ],
                    ),
            )));
  }
}
