part of xwidgetbase;

class XItem extends StatelessWidget {
  final bool titleOnTop;
  final String? title;
  final Color? titleColor;
  final Color? titleBorderColor;
  final TextStyle? titleStyle;

  ///Modificherai il widget dentro il TitleContainer senza toccare il widget che fa da contenitore
  final Widget? titleWidget;
  final TextAlign titleTextAlign;
  final double titleContainerWidth;
  final double? titleContainerHeight;

  ///Allineamento del Title solo se la Label è sopra
  final AlignmentGeometry? titleAlignOnTop;

  ///Allineamento del Title solo se la Label è a sinistra
  final AlignmentGeometry? titleAlignOnLeft;
  final Color? titleBackGroundColor;
  final double? titleWidthBorder;
  final Color? colorCard;

  ///Allineamento orizzontale dell'XItem
  final CrossAxisAlignment? crossAxisAlignmentXItem;

  ///Allineamento Verticale dell'XItem
  final MainAxisAlignment? mainAxisAlignmentXItem;
  final List<Widget>? children;
  // final bool visibleBottomBorderOfCard;
  final CrossAxisAlignment? childrensCrossAxisAlignment;
  final BoxConstraints? constraintsOfXItem;
  final Axis? wrapDirection;
  final double? wrapSpacing;
  final double? wrapRunSpacing;
  final double? wrapHeight;
  final double? width;
  final double? heightOfWidgetForEmptyList;

  final double? wrapWidth;
  final Decoration? decorationForListContainer;

  ///Utilizzato principalmente su APP
  final Function()? onTap;
  XItem({
    Key? key,
    this.onTap,
    this.width,
    this.decorationForListContainer,
    this.wrapSpacing,
    this.wrapWidth,
    this.wrapHeight,
    this.wrapRunSpacing,
    this.wrapDirection,
    this.titleAlignOnTop,
    this.mainAxisAlignmentXItem,
    this.titleWidget,
    this.crossAxisAlignmentXItem,
    this.heightOfWidgetForEmptyList,
    this.colorCard,
    this.titleStyle,
    this.titleAlignOnLeft,
    // this.visibleBottomBorderOfCard__ = false,
    this.titleColor,
    this.titleBorderColor,
    this.title = "",
    this.titleContainerWidth = 150,
    this.titleContainerHeight,
    this.children,
    this.childrensCrossAxisAlignment,
    this.titleOnTop = false,
    this.titleTextAlign = TextAlign.center,
    this.titleBackGroundColor,
    this.titleWidthBorder,
    double? height,
    BoxConstraints? constraintsOfXItem,
  })  : constraintsOfXItem = (width != null || height != null) ? constraintsOfXItem?.tighten(width: width, height: height) ?? BoxConstraints.tightFor(width: width, height: height) : constraintsOfXItem,
        super(key: key);

  static Widget? Three_ConcatenatedXItem<T, K>({
    ///WrapDirection dell'Item principale (Padre)
    required Axis wrapDirection,

    ///fontSize testi dell'Item principale (Padre)
    required double fontSizeForItem,

    ///Titolo dell'Item principale (Padre)
    required String title,

    ///Colore del titolo dell'Item principale (Padre)
    required Color? titleColor,

    ///Prima lista di Items che conterrà l'Item principale (Padre)
    required Iterable<MapEntry<dynamic, List<T>>> items,

    ///Widget per il titolo degli Items della prima lista
    required Widget Function(T) titleFirstWidget,

    ///Raggruppamento per ...., da mettere la propietà o le propietà per fare il groupBy per la seconda lista
    required K Function(T) secondGroupListsBy,

    ///Widget per il titolo degli Items della seconda lista
    required dynamic Function(T) titleSecondWidget,

    ///Widget per la visualizzazione delle Items finali della terza lista
    required Widget Function(T) thirdWidget,

    ///Da settare true nel caso si voglia un groupBy anche per la terza lista
    bool groupByForLastLevel = false,

    ///Raggruppamento per ...., da mettere la propietà o le propietà per fare il groupBy per la terza lista
    K Function(T)? groupListsBy_LastItems,

    ///Widget da riempire nel caso la propietà groupByForLastLevel sia true
    Widget Function(MapEntry<K, List<T>>)? thirdWidgetForGroupBy,
    bool titleFirstOnTop = true,
    bool titleSecondOnTop = false,
    bool? borderAllAroundList,
    Color? backGroundColorTitleContainer,
    Color? backGroundColor,
    Color? backGroundColorFirstXItem,
    Color? backGroundColorSecondXItem,
    Color? colorBorderOfarea,
    Color? colorBorderOfFirstWidget,
    Color? titleBorderColor,

    ///Larghezza dell'XItem Principale (Padre)
    double? width,

    ///Altezza dell'XItem Principale (Padre)
    double? height,
    double? titleContainerHeight,
    double? fontSizeForTitleOfArea,
    double? widthFirstXItem,
    double? widthSecondXItem,
    double? titleFirstContainerWidth,
    double? titleSecondContainerWidth,
    Axis? firstWrapDirection,
    Axis? secondWrapDirection,
    Axis? thirdWrapDirection,
  }) {
    var xi = XItem(title: title, titleColor: titleColor ?? colorBorderOfarea ?? Colors.white, titleOnTop: true, titleBackGroundColor: backGroundColorTitleContainer ?? null, titleContainerHeight: titleContainerHeight ?? 40, titleWidthBorder: 5, width: width, titleAlignOnTop: Alignment.center, titleContainerWidth: double.infinity, titleStyle: TextStyle(color: titleColor, fontSize: fontSizeForTitleOfArea ?? 24, fontWeight: FontWeight.bold), colorCard: backGroundColor, titleBorderColor: titleBorderColor, children: [
      items.length == 0
          ? XContainer(
              borderWidth: 5,
              titleBackColor: colorBorderOfarea ?? Colors.black,
              borderAll: borderAllAroundList ?? true,
              child: Container(
                height: 100,
                child: Row(children: [Expanded(child: Text("..nessuna..", textAlign: TextAlign.center, style: XStyles.xStyleText(fontSize: 30)))]),
              ))
          : XContainer(
              alignmentChild: Alignment.topLeft,
              heightChildContainer: height,
              borderWidth: 5,
              titleBackColor: colorBorderOfarea ?? Colors.black,
              child: Wrap(
                  spacing: 1,
                  runSpacing: 6,
                  direction: wrapDirection,
                  //1ST GRP
                  children: items.map((grp1) {
                    var xii = XItem(
                        wrapDirection: firstWrapDirection ?? Axis.vertical,
                        width: widthFirstXItem,
                        height: null,
                        wrapSpacing: 1,
                        wrapRunSpacing: 1,
                        titleWidget: grp1.value.map(titleFirstWidget).first,
                        colorCard: backGroundColorFirstXItem ?? Colors.blue.withOpacity(0.2),
                        crossAxisAlignmentXItem: CrossAxisAlignment.start,
                        mainAxisAlignmentXItem: MainAxisAlignment.start,
                        titleAlignOnTop: titleFirstOnTop != false ? Alignment.centerLeft : null,
                        titleContainerWidth: titleFirstOnTop != false ? double.infinity - 20 : titleFirstContainerWidth ?? 80,
                        titleOnTop: titleFirstOnTop,
                        titleStyle: TextStyle(color: colorBorderOfarea ?? titleColor, fontSize: 20),
                        // 2nd GROUP
                        children: grp1.value.groupListsBy<K>(secondGroupListsBy).entries.map((grp2) {
                          return Container(
                              child: XItem(
                            wrapDirection: secondWrapDirection ?? Axis.horizontal,
                            width: widthSecondXItem,
                            titleWidget: grp2.value.map(titleSecondWidget).first,
                            titleColor: XColors.foregroundLight,
                            titleAlignOnTop: titleSecondOnTop != false ? Alignment.centerLeft : null,
                            titleContainerWidth: titleSecondOnTop == false ? titleSecondContainerWidth ?? 50 : double.infinity - 20,
                            titleOnTop: titleSecondOnTop,
                            titleBackGroundColor: Colors.transparent,
                            colorCard: backGroundColorSecondXItem,
                            // 3th GROUP
                            children: [
                              XContainer(
                                  title: "",
                                  borderAll: true,
                                  titleBackColor: colorBorderOfFirstWidget != null ? colorBorderOfFirstWidget : Colors.transparent,
                                  backGroundColorInternalWidget: Colors.transparent,
                                  child: Wrap(
                                    direction: thirdWrapDirection ?? Axis.horizontal,
                                    children: groupByForLastLevel == false
                                        ? grp2.value.map(thirdWidget).toList()
                                        : //
                                        grp2.value.groupListsBy<K>(groupListsBy_LastItems!).entries.map(thirdWidgetForGroupBy!).toList(),
                                  )),
                            ],
                          ));
                        }).toList());
                    return xii;
                  }).toList())),
    ]);
    return xi;
  }

  static Widget One_ConcatenatedXItem<T>({
    ///fontSize testi dell'Item principale (Padre)
    required double fontSizeForItem,

    ///Titolo dell'Item principale (Padre)
    required String title,

    ///Colore del titolo dell'Item principale (Padre)
    required Color? titleColor,

    ///Prima lista di Items che conterrà l'Item principale (Padre)
    required List<T> items,

    ///Widget per la visualizzazione per gli items della lista
    required Widget Function(T) widgetItemInList,

    ///Altezza dell'XItem
    double? height,
    double? fontSizeForTitleOfArea,
    Axis? wrapDirectionForList,
    bool titleOnTop = true,
    bool borderAllAroundList = true,
    Color? backGroundColorTitleContainer,
    Color? backGroundColor,
    Color? titleBorderColor,
    double? titleContainerHeight,
    double? titleContainerWidth,
    AlignmentGeometry? titleAlignOnTop,
    AlignmentGeometry? titleAlignOnLeft,
    AlignmentGeometry? alignmentChild,
  }) {
    return XItem(title: title, titleColor: titleColor, titleOnTop: titleOnTop, colorCard: backGroundColor, titleWidthBorder: 5, titleBorderColor: titleBorderColor ?? titleColor ?? Colors.black, titleBackGroundColor: backGroundColorTitleContainer ?? Colors.black, titleAlignOnTop: titleAlignOnTop ?? Alignment.center, titleAlignOnLeft: titleAlignOnLeft ?? Alignment.centerLeft, titleContainerHeight: titleContainerHeight ?? 40, titleStyle: TextStyle(color: titleColor, fontSize: fontSizeForTitleOfArea, fontWeight: FontWeight.bold), titleContainerWidth: titleOnTop == true ? double.infinity : titleContainerWidth ?? 40, children: [
      items.length == 0
          // NESSUNA - VUOTO
          ? XContainer(
              borderWidth: 5,
              title: "",
              titleBackColor: titleBorderColor ?? Colors.black,
              borderAll: borderAllAroundList,
              child: Container(
                height: 100,
                child: Row(children: [
                  Expanded(child: Text("..nessuna..", textAlign: TextAlign.center, style: XStyles.xStyleText(fontSize: 30))),
                ]),
              ))
          // ITEMS
          : XContainer(
              heightChildContainer: height,
              borderWidth: 5,
              title: "",
              alignmentChild: alignmentChild ?? Alignment.topCenter,
              titleBackColor: titleColor,
              child: Wrap(
                spacing: 2,
                runSpacing: 2,
                direction: wrapDirectionForList ?? Axis.horizontal,
                //LIST
                children: items
                    .map(
                        //ITEM
                        widgetItemInList
                        //ITEM
                        )
                    .toList(),
              ))
    ]);
  }

  static Widget Two_ConcatenatedXItem<T, K>({
    required Axis wrapDirection,

    ///fontSize testi dell'Item principale (Padre)
    required double fontSizeForItem,

    ///Titolo dell'Item principale (Padre)

    ///Colore del titolo dell'Item principale (Padre)
    required Color? titleColor,

    ///Prima lista di Items che conterrà l'Item principale (Padre)
    required Iterable<MapEntry<dynamic, List<T>>> items,

    ///Widget per il titolo degli Items della prima lista
    required Widget Function(T) titleFirstWidget,

    ///Raggruppamento per ...., da mettere la propietà o le propietà per fare il groupBy per la terza lista
    required K Function(T) lastGroupListsBy,

    ///Widget da riempire per visualizzare gli items della seconda lista
    required Widget Function(MapEntry<K, List<T>>) lastWidgetForGroupBy,
    required Widget Function(T) lastWidget,

    ///Da settare false nel caso non si voglia un groupBy anche per l'ultima lista
    bool groupByForLastLevel = true,
    String? title,
    AlignmentGeometry? titleAlignOnTop,
    AlignmentGeometry? titleAlignOnLeft,
    CrossAxisAlignment? crossAxisAlignmentXItem,
    bool titleOnTop = true,
    bool titleFirstOnTop = true,
    bool? borderAllAroundList,
    bool? borderVisible,
    Color? backGroundColorTitleContainer,
    Color? colorBorderOfarea,
    Color? titleBorderColor,
    Color? firstBorderColorOfArea,
    Color? backGroundColor,
    Color? backGroundColorFirstXItem,
    Color? backGroundColorSecondXItem,
    Color? backGroundColorInternalXContainer,
    double? titleContainerHeight,
    double? titleContainerWidth,
    double? fontSizeForTitleOfArea,
    double? widthFirstXItem,
    double? widthSecondXItem,
    double? titleFirstContainerWidth,
    double? titleFirstContainerHeight,
    Axis? firstWrapDirection,
    Axis? secondWrapDirection,
    Axis? thirdWrapDirection,
  }) {
    return XItem(title: title, titleColor: colorBorderOfarea ?? Colors.black, titleOnTop: titleOnTop, titleBorderColor: titleBorderColor ?? Colors.black, titleContainerHeight: titleContainerHeight, colorCard: backGroundColor ?? Colors.black, titleWidthBorder: 5, titleBackGroundColor: backGroundColorTitleContainer ?? null, mainAxisAlignmentXItem: MainAxisAlignment.start, titleContainerWidth: titleContainerWidth ?? double.infinity, titleAlignOnTop: titleAlignOnTop ?? Alignment.center, titleAlignOnLeft: titleAlignOnLeft ?? Alignment.center, titleStyle: TextStyle(color: titleColor, fontSize: fontSizeForTitleOfArea, fontWeight: FontWeight.bold), children: [
      items.length == 0
          // NESSUNA - VUOTO
          ? XContainer(borderVisible: borderVisible ?? true, title: "", titleBackColor: colorBorderOfarea ?? Colors.black, borderAll: true, child: Container(height: 40, child: Row(children: [Expanded(child: Text("...nessuno...", textAlign: TextAlign.center, style: XStyles.xStyleText(fontSize: 30)))])))
          // ITEMS
          : XContainer(
              borderVisible: borderVisible ?? true,
              borderWidth: 5,
              backGroundColorInternalWidget: backGroundColorInternalXContainer ?? Colors.grey[900],
              title: "",
              titleBackColor: colorBorderOfarea ?? Colors.black,
              child: Wrap(
                  spacing: 1,
                  runSpacing: 1,
                  direction: Axis.horizontal,

                  //1ST GROUP
                  children: items
                      .map((grp) => XItem(
                            titleWidget: grp.value.map(titleFirstWidget).first,
                            //                         crossAxisAlignmentXItem: CrossAxisAlignment.start,
                            crossAxisAlignmentXItem: crossAxisAlignmentXItem ?? CrossAxisAlignment.center,
                            titleAlignOnTop: Alignment.center,
                            titleBackGroundColor: backGroundColorTitleContainer,
                            titleContainerWidth: titleFirstOnTop == true ? titleFirstContainerWidth ?? 250 : titleFirstContainerWidth ?? 200,
                            titleOnTop: titleFirstOnTop,
                            titleContainerHeight: titleFirstContainerHeight,
                            width: widthFirstXItem,
                            children: [
                              ///Widget che visualizza Wrapped la lista delle Navi
                              XContainer(
                                  title: "",
                                  borderAll: true,

                                  // backGroundColorInternalWidget: Colors.black,
                                  titleBackColor: firstBorderColorOfArea ?? titleColor,
                                  child: Wrap(
                                      spacing: 1,
                                      runSpacing: 1,
                                      direction: Axis.horizontal,
                                      // 2nd GROUP LIST
                                      children: groupByForLastLevel == true
                                          ? grp.value
                                              .groupListsBy<K>(lastGroupListsBy)
                                              .entries
                                              .map(
                                                //ITEM
                                                lastWidgetForGroupBy,
                                                //ITEM
                                              )
                                              .toList()
                                          : grp.value.map(lastWidget).toList()))
                            ],
                          ))
                      .toList())),
    ]);
  }

  @override
  Widget build(BuildContext context) {
    return GestureDetector(
        onTap: onTap,
        child: ConstrainedBox(
          constraints: constraintsOfXItem ?? BoxConstraints(),
          child: Container(
            width: width,
            child: Card(
              color: colorCard ?? Colors.transparent,
              child: Container(
                  // decoration: visibleBottomBorderOfCard == true ? BoxDecoration(border: Border(bottom: BorderSide(width: 6, color: Colors.blue.withOpacity(0.5)))) : null,
                  child: Column(
                mainAxisSize: MainAxisSize.min,
                mainAxisAlignment: mainAxisAlignmentXItem ?? MainAxisAlignment.center,
                crossAxisAlignment: crossAxisAlignmentXItem ?? CrossAxisAlignment.center,
                children: [
                  !titleOnTop || title == null
                      ? Container()
                      : Container(
                          alignment: titleAlignOnTop ?? Alignment.center,
                          width: titleContainerWidth,
                          height: titleContainerHeight,
                          color: titleBackGroundColor != null ? null : titleBackGroundColor ?? Colors.transparent,
                          margin: EdgeInsets.fromLTRB(0, 0, 0, 0),
                          decoration: titleBackGroundColor != null
                              ? BoxDecoration(
                                  color: titleBackGroundColor ?? Colors.transparent,
                                  border: Border(
                                    top: BorderSide(color: titleBorderColor ?? Colors.transparent, width: titleWidthBorder ?? 2),
                                    left: BorderSide(color: titleBorderColor ?? Colors.transparent, width: titleWidthBorder ?? 2),
                                    right: BorderSide(color: titleBorderColor ?? Colors.transparent, width: titleWidthBorder ?? 2),
                                    // bottom: BorderSide(color: colortitle ?? Colors.transparent, width: widthBorderTitleContainer ?? 2),
                                  ))
                              : null,
                          child: titleWidget ??
                              Container(
                                alignment: titleAlignOnTop,
                                height: titleContainerHeight,
                                child: Text(title!, textAlign: titleTextAlign, style: titleStyle ?? XStyles.xStyTextForLabel(titleColor)),
                              )),
                  Container(
                    child: Row(children: [
                      titleOnTop || title == null
                          ? Container()
                          : Container(
                              alignment: titleAlignOnLeft ?? Alignment.center,
                              width: titleContainerWidth,
                              height: titleContainerHeight,
                              padding: EdgeInsets.symmetric(vertical: 2),
                              color: titleBackGroundColor ?? Colors.transparent,
                              margin: EdgeInsets.fromLTRB(0, 0, 0, 0),
                              child: titleWidget ??
                                  Container(
                                    height: titleContainerHeight,
                                    child: Text(
                                      title!,
                                      textAlign: titleTextAlign,
                                      style: titleStyle ?? XStyles.xStyTextForLabel(titleColor),
                                    ),
                                  )),
                      Flexible(
                          child: Container(
                              decoration: decorationForListContainer,
                              child: Wrap(
                                crossAxisAlignment: WrapCrossAlignment.center,
                                direction: wrapDirection ?? Axis.horizontal,
                                spacing: wrapSpacing ?? 5,
                                runSpacing: wrapRunSpacing ?? 5,
                                children: children!,
                              )))
                    ]),
                  )
                ],
              )),
            ),
          ),
        ));
  }
}
