part of xwidgetbase;

class XfxScheda extends StatefulWidget {
  XfxScheda({
    Key? key,
    this.titleScheda = "",
    this.visibleXContainerWithLabelOnTop = true,
    this.child,
    this.listOfChildren,
    this.bottomNavigationBarvisible = true,
    this.onTapOnBTNofMenu,
    this.currentIndexOfBottomMenu,
    required this.childrenOfBottomBar,
  }) : super(key: key);
  final String titleScheda;
  final bool visibleXContainerWithLabelOnTop;
  final Widget? child;
  final Function(int)? onTapOnBTNofMenu;
  final List<Widget>? listOfChildren;
  final bool? bottomNavigationBarvisible;
  final int? currentIndexOfBottomMenu;

  List<BottomNavigationBarItem> childrenOfBottomBar;
  @override
  _XfxSchedaState createState() => _XfxSchedaState();
}

class _XfxSchedaState extends State<XfxScheda> {
  @override
  void initState() {
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
        backgroundColor: XColors.backgroundDark,
        body: Container(
            margin: EdgeInsets.symmetric(horizontal: 15),
            child: Column(children: [
              SizedBox(height: 10),
              widget.visibleXContainerWithLabelOnTop == true
                  ? Row(
                      children: [
                        Expanded(child: XContainerWithLabel(widget.titleScheda, height: 30, color: XColors.backGroundTitleContainerForScheda_MAIN, textStyle: XStyles.xStyTextForTextBase(XColors.foregroundDark))),
                      ],
                    )
                  : Container(),
              SizedBox(height: 3),
              SingleChildScrollView(
                child: Container(
                  child: widget.child ?? Container(),
                ),
              ),
              SizedBox(height: 5),
            ])),
        bottomNavigationBar: widget.bottomNavigationBarvisible == true
            ? BottomNavigationBar(
                type: BottomNavigationBarType.fixed,
                currentIndex: widget.currentIndexOfBottomMenu ?? 0,
                onTap: widget.onTapOnBTNofMenu,
                enableFeedback: true,
                showUnselectedLabels: true,
                selectedItemColor: Colors.blue[700],
                selectedFontSize: 15,
                selectedLabelStyle: XStyles.xStyleText(fontSize: 10),
                backgroundColor: Colors.grey[900],
                unselectedItemColor: XColors.foregroundLight,
                unselectedFontSize: 10,
                unselectedLabelStyle: XStyles.xStyleText(fontSize: 10),
                iconSize: 20,
                items: widget.childrenOfBottomBar,
              )
            : Container(
                height: 1,
              ));
  }
}
